
vertex   struc
  vtx_x3d                dd 0 ; 3d world co-ordinates
  vtx_y3d                dd 0
  vtx_z3d                dd 0
  vtx_x2d                dd 0
  vtx_y2d                dd 0
  vtx_is_done            db 0 ; set to "_global_frame_number" if done
  vtx_is_clipped         db 0 ; set to 1 if it is outside screen boundaries
  vtx_vertex_contrast    db 0
  vtx_is_contrast_used   db 0
  vtx_translation        dd 0 ; offset to translation vertex (object -> camera)
vertex   ends

poly_connection  struc
  pc_previous_vertex    dd 0
  pc_this_vertex        dd 0
  pc_next_vertex        dd 0
  pc_texture_x          dd 0
  pc_texture_y          dd 0
  pc_next_link          dd 0
  pc_previous_link      dd 0
poly_connection  ends

plane_equation struc
  pe_constant_a         dd 0 ; a,b,c,d of plane equation (world)
  pe_constant_b         dd 0
  pe_constant_c         dd 0
  pe_constant_d         dd 0
  pe_is_shading_used    dd 0
  pe_contrast           dd 0
  pe_distance_reduction dd 0 ; offset to location to grab info about distance moved
  pe_runtime_distance   dd 0 ; floating "bar graph" of distances
  pe_is_visable         dd 0 ; 0 if visable, 1 if not.  Can only be 0 or 1
plane_equation ends

bsp struc
  bsp_node_equation      dd 0 ; offset to plane equation controlling node
  bsp_right_node         dd 0 ; offset to right bsp node
  bsp_left_node          dd 0 ; offset to left bsp node
  bsp_surface_0          dd 0 ; offset to side 0 polygon structure
  bsp_surface_1          dd 0 ; offset to side 1 polygon structure
bsp ends

polygon struc
  pg_surface_type       dd 0 ; bits controlling surface type/method
  pg_vertex_count       dd 0 ; number of verticies in polygon
  pg_polygon_colour     dd 0 ; colour of polygon/texture number
  pg_poly_list          dd 0 ; offset to first poly_connection (linked list)
  pg_poly_equation      dd 0 ; offset to plane equation (for flat shaded intensity)
polygon ends

vertex_links struc
  vl_used_vertex        dd 0 ; offset to a vertex which is used in an object
  vl_next_vertex_link   dd 0 ; offset to next link
vertex_links ends

plane_links struc
  pl_used_equation      dd 0 ; offset to a plane equation which is used in an object
  pl_next_equation_link dd 0 ; offset to next link
plane_links ends

